package cry;

import java.math.BigInteger;

/**
 * one elliptic curve in form y^2=x^3+ax+b
 *
 * @author matecsaba
 */
public class cryECcurve {

    /**
     * name
     */
    public final String nam;

    /**
     * oid
     */
    public final int[] oid;

    /**
     * prime
     */
    public final BigInteger p;

    /**
     * a
     */
    public final BigInteger a;

    /**
     * b
     */
    public final BigInteger b;

    /**
     * generator
     */
    public final cryECpoint g;

    /**
     * order
     */
    public final BigInteger n;

    /**
     * create one curve
     *
     * @param mna name
     * @param mo oid
     * @param mp prime
     * @param ma a
     * @param mb b
     * @param mx gx
     * @param my gy
     * @param mn order
     */
    public cryECcurve(String mna, int[] mo, BigInteger mp, BigInteger ma, BigInteger mb, BigInteger mx, BigInteger my, BigInteger mn) {
        nam = mna;
        oid = mo;
        p = mp;
        a = ma;
        b = mb;
        n = mn;
        g = new cryECpoint(this, mx, my);
    }

    public String toString() {
        return nam;
    }

    /**
     * curves
     */
    public static final cryECcurve[] curves = {
        new cryECcurve("nistp112r1", new int[]{0x2b, 0x81, 0x04, 0x00, 6},
        new BigInteger("DB7C2ABF62E35E668076BEAD208B", 16),
        new BigInteger("DB7C2ABF62E35E668076BEAD2088", 16),
        new BigInteger("659EF8BA043916EEDE8911702B22", 16),
        new BigInteger("09487239995A5EE76B55F9C2F098", 16),
        new BigInteger("A89CE5AF8724C0A23E0E0FF77500", 16),
        new BigInteger("DB7C2ABF62E35E7628DFAC6561C5", 16)),
        new cryECcurve("nistp112r2", new int[]{0x2b, 0x81, 0x04, 0x00, 7},
        new BigInteger("DB7C2ABF62E35E668076BEAD208B", 16),
        new BigInteger("6127C24C05F38A0AAAF65C0EF02C", 16),
        new BigInteger("51DEF1815DB5ED74FCC34C85D709", 16),
        new BigInteger("4BA30AB5E892B4E1649DD0928643", 16),
        new BigInteger("ADCD46F5882E3747DEF36E956E97", 16),
        new BigInteger("36DF0AAFD8B8D7597CA10520D04B", 16)),
        new cryECcurve("nistp128r1", new int[]{0x2b, 0x81, 0x04, 0x00, 28},
        new BigInteger("FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF", 16),
        new BigInteger("FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFC", 16),
        new BigInteger("E87579C11079F43DD824993C2CEE5ED3", 16),
        new BigInteger("161FF7528B899B2D0C28607CA52C5B86", 16),
        new BigInteger("CF5AC8395BAFEB13C02DA292DDED7A83", 16),
        new BigInteger("FFFFFFFE0000000075A30D1B9038A115", 16)),
        new cryECcurve("nistp128r2", new int[]{0x2b, 0x81, 0x04, 0x00, 29},
        new BigInteger("FFFFFFFDFFFFFFFFFFFFFFFFFFFFFFFF", 16),
        new BigInteger("D6031998D1B3BBFEBF59CC9BBFF9AEE1", 16),
        new BigInteger("5EEEFCA380D02919DC2C6558BB6D8A5D", 16),
        new BigInteger("7B6AA5D85E572983E6FB32A7CDEBC140", 16),
        new BigInteger("27B6916A894D3AEE7106FE805FC34B44", 16),
        new BigInteger("3FFFFFFF7FFFFFFFBE0024720613B5A3", 16)),
        new cryECcurve("nistp160k1", new int[]{0x2b, 0x81, 0x04, 0x00, 9},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFAC73", 16),
        new BigInteger("0", 16),
        new BigInteger("7", 16),
        new BigInteger("3B4C382CE37AA192A4019E763036F4F5DD4D7EBB", 16),
        new BigInteger("938CF935318FDCED6BC28286531733C3F03C4FEE", 16),
        new BigInteger("0100000000000000000001B8FA16DFAB9ACA16B6B3", 16)),
        new cryECcurve("nistp160r1", new int[]{0x2b, 0x81, 0x04, 0x00, 8},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFF", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7FFFFFFC", 16),
        new BigInteger("1C97BEFC54BD7A8B65ACF89F81D4D4ADC565FA45", 16),
        new BigInteger("4A96B5688EF573284664698968C38BB913CBFC82", 16),
        new BigInteger("23A628553168947D59DCC912042351377AC5FB32", 16),
        new BigInteger("0100000000000000000001F4C8F927AED3CA752257", 16)),
        new cryECcurve("nistp160r2", new int[]{0x2b, 0x81, 0x04, 0x00, 30},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFAC73", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFAC70", 16),
        new BigInteger("B4E134D3FB59EB8BAB57274904664D5AF50388BA", 16),
        new BigInteger("52DCB034293A117E1F4FF11B30F7199D3144CE6D", 16),
        new BigInteger("FEAFFEF2E331F296E071FA0DF9982CFEA7D43F2E", 16),
        new BigInteger("0100000000000000000000351EE786A818F3A1A16B", 16)),
        new cryECcurve("nistp192k1", new int[]{0x2b, 0x81, 0x04, 0x00, 31},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFEE37", 16),
        new BigInteger("0", 16),
        new BigInteger("3", 16),
        new BigInteger("DB4FF10EC057E9AE26B07D0280B7F4341DA5D1B1EAE06C7D", 16),
        new BigInteger("9B2F2F6D9C5628A7844163D015BE86344082AA88D95E2F9D", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFE26F2FC170F69466A74DEFD8D", 16)),
        new cryECcurve("nistp192r1", new int[]{1, 2, 840, 10045, 1, 1, 1},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFF", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFC", 16),
        new BigInteger("64210519E59C80E70FA7E9AB72243049FEB8DEECC146B9B1", 16),
        new BigInteger("188DA80EB03090F67CBF20EB43A18800F4FF0AFD82FF1012", 16),
        new BigInteger("07192B95FFC8DA78631011ED6B24CDD573F977A11E794811", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFF99DEF836146BC9B1B4D22831", 16)),
        new cryECcurve("nistp224k1", new int[]{0x2b, 0x81, 0x04, 0x00, 31},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFE56D", 16),
        new BigInteger("0", 16),
        new BigInteger("5", 16),
        new BigInteger("A1455B334DF099DF30FC28A169A467E9E47075A90F7E650EB6B7A45C", 16),
        new BigInteger("7E089FED7FBA344282CAFBD6F7E319F7C0B0BD59E2CA4BDB556D61A5", 16),
        new BigInteger("010000000000000000000000000001DCE8D2EC6184CAF0A971769FB1F7", 16)),
        new cryECcurve("nistp224r1", new int[]{0x2b, 0x81, 0x04, 0x00, 33},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF000000000000000000000001", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFFFFFFFFFFFFFFFFFE", 16),
        new BigInteger("B4050A850C04B3ABF54132565044B0B7D7BFD8BA270B39432355FFB4", 16),
        new BigInteger("B70E0CBD6BB4BF7F321390B94A03C1D356C21122343280D6115C1D21", 16),
        new BigInteger("BD376388B5F723FB4C22DFE6CD4375A05A07476444D5819985007E34", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFF16A2E0B8F03E13DD29455C5C2A3D", 16)),
        new cryECcurve("nistp256k1", new int[]{0x2b, 0x81, 0x04, 0x00, 10},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFC2F", 16),
        new BigInteger("0", 16),
        new BigInteger("7", 16),
        new BigInteger("79BE667EF9DCBBAC55A06295CE870B07029BFCDB2DCE28D959F2815B16F81798", 16),
        new BigInteger("483ADA7726A3C4655DA4FBFC0E1108A8FD17B448A68554199C47D08FFB10D4B8", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEBAAEDCE6AF48A03BBFD25E8CD0364141", 16)),
        new cryECcurve("nistp256r1", new int[]{1, 2, 840, 10045, 1, 1, 7},
        new BigInteger("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFF", 16),
        new BigInteger("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFC", 16),
        new BigInteger("5AC635D8AA3A93E7B3EBBD55769886BC651D06B0CC53B0F63BCE3C3E27D2604B", 16),
        new BigInteger("6B17D1F2E12C4247F8BCE6E563A440F277037D812DEB33A0F4A13945D898C296", 16),
        new BigInteger("4FE342E2FE1A7F9B8EE7EB4A7C0F9E162BCE33576B315ECECBB6406837BF51F5", 16),
        new BigInteger("FFFFFFFF00000000FFFFFFFFFFFFFFFFBCE6FAADA7179E84F3B9CAC2FC632551", 16)),
        new cryECcurve("nistp384r1", new int[]{0x2b, 0x81, 0x04, 0x00, 34},
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFF0000000000000000FFFFFFFF", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEFFFFFFFF0000000000000000FFFFFFFC", 16),
        new BigInteger("B3312FA7E23EE7E4988E056BE3F82D19181D9C6EFE8141120314088F5013875AC656398D8A2ED19D2A85C8EDD3EC2AEF", 16),
        new BigInteger("AA87CA22BE8B05378EB1C71EF320AD746E1D3B628BA79B9859F741E082542A385502F25DBF55296C3A545E3872760AB7", 16),
        new BigInteger("3617DE4A96262C6F5D9E98BF9292DC29F8F41DBD289A147CE9DA3113B5F0B8C00A60B1CE1D7E819D7A431D7C90EA0E5F", 16),
        new BigInteger("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC7634D81F4372DDF581A0DB248B0A77AECEC196ACCC52973", 16)),
        new cryECcurve("nistp521r1", new int[]{0x2b, 0x81, 0x04, 0x00, 35},
        new BigInteger("01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF", 16),
        new BigInteger("01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC", 16),
        new BigInteger("0051953EB9618E1C9A1F929A21A0B68540EEA2DA725B99B315F3B8B489918EF109E156193951EC7E937B1652C0BD3BB1BF073573DF883D2C34F1EF451FD46B503F00", 16),
        new BigInteger("00C6858E06B70404E9CD9E3ECB662395B4429C648139053FB521F828AF606B4D3DBAA14B5E77EFE75928FE1DC127A2FFA8DE3348B3C1856A429BF97E7E31C2E5BD66", 16),
        new BigInteger("011839296A789A3BC0045C8A5FB42C7D1BD998F54449579B446817AFBD17273E662C97EE72995EF42640C550B9013FAD0761353C7086A272C24088BE94769FD16650", 16),
        new BigInteger("01FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA51868783BF2F966B7FCC0148F709A5D03BB5C9B8899C47AEBB6FB71E91386409", 16)),};

    /**
     * get by size
     *
     * @param len length in bits
     * @return curve
     */
    public static cryECcurve getBySize(int len) {
        int o = -1;
        for (int i = curves.length - 1; i >= 0; i--) {
            if (curves[i].p.bitLength() >= len) {
                o = i;
            }
        }
        if (o < 0) {
            return null;
        } else {
            return curves[o];
        }
    }

    /**
     * get by name
     *
     * @param nam name
     * @return curve
     */
    public static cryECcurve getByName(String nam) {
        int o = -1;
        for (int i = 0; i < curves.length; i++) {
            if (curves[i].nam.equals(nam)) {
                o = i;
            }
        }
        if (o < 0) {
            return null;
        } else {
            return curves[o];
        }
    }

    private static boolean compareOids(int[] o1, byte[] o2) {
        if (o1.length != o2.length) {
            return false;
        }
        for (int i = 0; i < o1.length; i++) {
            if (o1[i] != (o2[i] & 0xff)) {
                return false;
            }
        }
        return true;
    }

    /**
     * get by oid
     *
     * @param oid oid
     * @return curve
     */
    public static cryECcurve getByOid(byte[] oid) {
        int o = -1;
        for (int i = 0; i < curves.length; i++) {
            if (compareOids(curves[i].oid, oid)) {
                o = i;
            }
        }
        if (o < 0) {
            return null;
        } else {
            return curves[o];
        }
    }

}
